=== testing/adios2/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(interface)
add_subdirectory(engine)
add_subdirectory(transports)
add_subdirectory(bindings)
add_subdirectory(xml)
add_subdirectory(yaml)
add_subdirectory(performance)
add_subdirectory(helper)
