=== debian/changelog ===
adios2 (2.5.0+g2020.05.21+dfsg1-1~) UNRELEASED; urgency=medium

  * Initial release (Closes: #960339)

 -- Kyle Edwards <kyle.edwards@kitware.com>  Wed, 13 May 2020 19:37:53 +0000
